Class | WEBrick::HTTPAuth::BasicAuth
In: | webrick/httpauth/basicauth.rb
Parent: | Object

### Methods

authenticate challenge make_passwd new

### Included Modules

Authenticator

### Constants

AuthScheme | = | "Basic"

### Attributes

logger | [R] |
realm | [R] |
userdb | [R] |

### Public Class methods

make_passwd(realm, user, pass)

[Source]

    # File webrick/httpauth/basicauth.rb, line 21
          def self.make_passwd(realm, user, pass)
            pass ||= ""
            pass.crypt(Utils::random_string(2))
          end

new(config, default=Config::BasicAuth)

[Source]

    # File webrick/httpauth/basicauth.rb, line 28
          def initialize(config, default=Config::BasicAuth)
            check_init(config)
            @config = default.dup.update(config)
          end

### Public Instance methods

authenticate(req, res)

[Source]

    # File webrick/httpauth/basicauth.rb, line 33
          def authenticate(req, res)
            unless basic_credentials = check_scheme(req)
              challenge(req, res)
            end
            userid, password = basic_credentials.unpack("m*")[0].split(":", 2)
            password ||= ""
            if userid.empty?
              error("user id was not given.")
              challenge(req, res)
            end
            unless encpass = @userdb.get_passwd(@realm, userid, @reload_db)
              error("%s: the user is not allowed.", userid)
              challenge(req, res)
            end
            if password.crypt(encpass) != encpass
              error("%s: password unmatch.", userid)
              challenge(req, res)
            end
            info("%s: authentication succeeded.", userid)
            req.user = userid
          end

challenge(req, res)

[Source]

    # File webrick/httpauth/basicauth.rb, line 55
          def challenge(req, res)
            res[@response_field] = "#{@auth_scheme} realm=\"#{@realm}\""
            raise @auth_exception
          end

[Validate]